//This file contains macros to place stones on the middle way

#declare PlaceSeed = seed(314159);
#declare RotationSeed = seed( 1234 );
#declare ScaleSeed = seed( 655 );

#declare SphereRadius = 1;

#declare SphereFunc = function{ x*x + y*y + z*z - SphereRadius * SphereRadius }
#declare PatFunc = function{ pattern{ dents } }

#declare IsoStone = 
isosurface{
    function{ SphereFunc(x,y,z) - PatFunc(x,y,z)*2 }
    contained_by{ sphere{ 0, 2 } }
    max_gradient 5.3
    accuracy 0.001
    threshold 0
    pigment{ color srgb 0.8 }
}

#macro PlaceStones(MinBox, MaxBox, SquareInterval, InnerSquareInterval)
    #for( X_Pos, MinBox.x, MaxBox.x, SquareInterval )
        #for(Z_Pos, MinBox.z, MaxBox.z, SquareInterval )
            #local NoisePosX = 0;
            #local NoisePosZ = 0;
            AffineTimeSetterBoundOnly(0, 1, -InnerSquareInterval / 2, InnerSquareInterval / 2, NoisePosX, rand(PlaceSeed) )
            AffineTimeSetterBoundOnly(0, 1, -InnerSquareInterval / 2, InnerSquareInterval / 2, NoisePosZ, rand(PlaceSeed) )
            #local GlobalScale = 1;
            AffineTimeSetterBoundOnly(0, 1, 0.5, 1.25, GlobalScale, rand(ScaleSeed) )
            #local StonePos = < X_Pos + NoisePosX, 0, Z_Pos + NoisePosZ>;
            object{ IsoStone rotate < 360 * rand(RotationSeed), 360 * rand(RotationSeed),360 * rand(RotationSeed)> scale <0.25, 0.175, 0.25>*GlobalScale translate StonePos }        
        #end
    #end
#end

